## ros-noetic-openhrp3 3.1.10

=== CMakeLists.txt ===

# Copyright (c) 2008, AIST, the University of Tokyo and General Robotix Inc.
# All rights reserved. This program is made available under the terms of the
# Eclipse Public License v1.0 which accompanies this distribution, and is
# available at http://www.eclipse.org/legal/epl-v10.html
# Contributors:
# National Institute of Advanced Industrial Science and Technology (AIST)
# General Robotix Inc. 

# @author Shin'ichiro Nakaoka


cmake_minimum_required(VERSION 2.4)

if( NOT WIN32)
  if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
  endif(COMMAND cmake_policy)
endif()

project(OpenHRP)

option(BUILD_GOOGLE_TEST "Build google test." OFF)
if(BUILD_GOOGLE_TEST)
  enable_testing()
  add_subdirectory(/usr/src/gtest ${CMAKE_CURRENT_BINARY_DIR}/gtest)
endif()

set(OPENHRP_VERSION_MAJOR 3)
set(OPENHRP_VERSION_MINOR 1)
set(OPENHRP_VERSION_MICRO 10)
set(OPENHRP_VERSION_ADD_TAIL )
set(CPACK_DEBIAN_PACKAGE_VERSION_TAIL 0)

set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/)

include(FindPkgConfig)
include(CheckIncludeFiles)
include(${CMAKE_MODULE_PATH}GetUbuntuVer.cmake)

# Enable SSE options
# include(${CMAKE_MODULE_PATH}FindSSEArchitecture.cmake)

if( CMAKE_VERBOSE_MAKEFILE )
  set(VERBOSE_FLAG -v)
  set(JAVAC_VFLAG -verbose)
endif()

option(ENABLE_INSTALL_RPATH "Enable RPATH setting for installed binary files" OFF)
option(ENABLE_INSTALL_RPATH_TO_SELF "Make the binaries that can work anywhere in the filesystem" OFF)

SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

if(NOT ENABLE_INSTALL_RPATH AND NOT ENABLE_INSTALL_RPATH_TO_SELF)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
  SET(CMAKE_INSTALL_RPATH "")
  SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
else()
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE) 
  if(ENABLE_INSTALL_RPATH)
    SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  endif()
  if(ENABLE_INSTALL_RPATH_TO_SELF)
    SET(CMAKE_INSTALL_RPATH "$ORIGIN/../lib")
  endif()
endif()


# commands
if(UNIX)
  set(RMDIR rm -fr)
  set(COPY_COMMAND cp)
  set(CPSEP ":")
elseif(WIN32)
  set(RMDIR rmdir /S/Q)
  set(COPY_COMMAND copy /Y)
  set(CPSEP "\;")
endif()

# shell script file suffix
if(UNIX)
  set(SH_SFX "sh")
elseif(WIN32)
  set(SH_SFX "bat")
endif()

# CPack presetting
if(UNIX)
  option(GENERATE_DEBIANPACKAGE "When generate debian package you set ON." OFF)
endif()


# check "dlfcn.h" for using dlopen() and dlclose()
if(UNIX)
  check_include_files(dlfcn.h HAVE_DLFCN_H)
  if(NOT HAVE_DLFCN_H)
    message(FATAL_ERROR "Could not find dlfcn.h")
  endif()
endif()

# check boost
set(Boost_USE_STATIC_LIBS OFF)
set(Boost_NO_BOOST_CMAKE 1)
set(Boost_ADDITIONAL_VERSIONS "1.42" "1.42.0" "1.43" "1.43.0" "1.44" "1.44.0" "1.45" "1.45.0" "1.46" "1.46.0" "1.46.1" "1.47" "1.47.0" "1.48" "1.48.0" "1.49.0" "1.50.0")

#if(NOT Boost_INCLUDE_DIR AND NOT Boost_LIBRARY_DIRS)
  if(WIN32)
    if( "$ENV{BOOST_ROOT}" STREQUAL "" )
      find_path(
        BOOST_ROOT
        NAMES boost/algorithm boost/bind boost/regex boost/thread boost/numeric
        PATHS $ENV{HOMEDRIVE}/Program Files $ENV{HOMEDRIVE}/
        PATH_SUFFIXES Boost_1_44 Boost-1.41.0 Boost-1.40.0 Boost-1.39.0 Boost-1.38.0 Boost-1.37.0 Boost-1.36.0 Boost-1.35.0
        DOC "The root directory of boost")
    else()
      set(BOOST_ROOT $ENV{BOOST_ROOT} CACHE PATH "The root directory of boost")
    endif()
    find_package(Boost 1.35.0 REQUIRED )
  elseif(UNIX)
    find_package(Boost 1.68.0 QUIET)
    if(Boost_FOUND)
      find_package(Boost 1.68.0 REQUIRED COMPONENTS filesystem system regex program_options thread)
    else()
      find_package(Boost 1.35.0 QUIET)
      if(Boost_FOUND)
        find_package(Boost 1.35.0 REQUIRED COMPONENTS filesystem signals system regex program_options thread)
      else()
        find_package(Boost 1.34.0 REQUIRED COMPONENTS filesystem signals regex program_options thread)
      endif()
    endif()
    if(NOT Boost_FOUND)
     set(BOOST_ROOT ${BOOST_ROOT} CACHE PATH "set the directory of the boost library")
     message(FATAL_ERROR "Boost cannot be found. Please specify the boost top directory to BOOST_ROOT.")
   endif()
  endif()
#endif()

include_directories(${Boost_INCLUDE_DIRS})
link_directories(${Boost_LIBRARY_DIRS})

# check blas and lapack
find_package(Lapack REQUIRED)

include_directories(${LAPACK_INCLUDE_DIRS})
link_directories(${LAPACK_LIBRARY_DIRS})


# eigen
find_package(Eigen)
include_directories(${EIGEN_INCLUDE_DIR})

# build flag of jpeg and png library
if(UNIX)
  set(PNG_JPEG_BUILD OFF CACHE BOOL "Do you want to build png and jpeg library " )
elseif(WIN32)
  set(PNG_JPEG_BUILD ON CACHE BOOL "Do you want to build png and jpeg library " )
endif()

# jpeg
if(PNG_JPEG_BUILD)
  set(JPEG_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/hrplib/hrpUtil/Jpeg-6b" ) 
  if(UNIX)
    set(JPEG_LIBRARY jpeg)
  elseif(WIN32)
    set(JPEG_LIBRARY libjpeg)
  endif()
else()
  if(UNIX)
    find_package(JPEG REQUIRED)
  elseif(WIN32)
    set(JPEG_INCLUDE_DIR CACHE PATH "Directories for searching jpeg include files" )
    set(JPEG_LIBRARY_DIR CACHE PATH "Directories for searching jpeg library files" )
    if(NOT JPEG_INCLUDE_DIR OR NOT JPEG_LIBRARY_DIR)
      message(FATAL_ERROR "JPEG library required, please specify it's location.")
    endif()
    link_directories(${JPEG_LIBRARY_DIR})
    set(JPEG_LIBRARY libjpeg)
  endif()
endif()
include_directories(${JPEG_INCLUDE_DIR})

# png
if(PNG_JPEG_BUILD)
  set(PNG_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/hrplib/hrpUtil/lpng1232" ) 
  if(UNIX)
    set(PNG_LIBRARY png)
  elseif(WIN32)
    set(PNG_LIBRARY libpng)
  endif()
else()
  if(UNIX)
    find_package(PNG REQUIRED)
  elseif(WIN32)
    set(PNG_INCLUDE_DIR CACHE PATH "Directories for searching png include files" )
    set(PNG_LIBRARY_DIR CACHE PATH "Directories for searching png library files" )
    if(NOT PNG_INCLUDE_DIR OR NOT PNG_LIBRARY_DIR)
      message(FATAL_ERROR "PNG library required, please specify it's location.")
    endif()
    link_directories(${PNG_LIBRARY_DIR})
    set(PNG_LIBRARY libpng)
  endif()
endif()
include_directories(${PNG_INCLUDE_DIR})

#zlib
if(PNG_JPEG_BUILD)
  set(ZLIB_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/hrplib/hrpUtil/zlib123" )
  include_directories(${ZLIB_INCLUDE_DIR})
  set(ZLIB_LIBRARY zlib)
else()
  if(WIN32)
    set(ZLIB_INCLUDE_DIR CACHE PATH "Directories for searching zlib include files" )
    set(ZLIB_LIBRARY_DIR CACHE PATH "Directories for searching zlib library files" )
    if(NOT ZLIB_INCLUDE_DIR OR NOT ZLIB_LIBRARY_DIR)
      message(FATAL_ERROR "ZLIB library required, please specify it's location.")
    endif()
    include_directories(${ZLIB_INCLUDE_DIR})
    link_directories(${ZLIB_LIBRARY_DIR})
    set(ZLIB_LIBRARY zlib)
  endif()
endif()


# omniORB
if(UNIX)
  if(NOT OMNIORB_DIR)
    pkg_check_modules(OMNIORB REQUIRED omniORB4)
    if(OMNIORB_FOUND)
      set(OMNIORB_DIR ${OMNIORB_PREFIX})
      message(STATUS "Found omniORB ${OMNIORB_VERSION} in ${OMNIORB_PREFIX}")
    endif()
  else()
    set(OMNIORB_INCLUDE_DIRS ${OMNIORB_DIR}/include)
    set(OMNIORB_LIBRARY_DIRS ${OMNIORB_DIR}/lib)
    if(QNXNTO)
      set(OMNIORB_LIBRARIES ${OMNIORB_LIBRARIES} socket)
    endif(QNXNTO)
  endif()
elseif(WIN32)
  if(NOT OMNIORB_DIR)
    if( NOT $ENV{OMNI_ROOT} STREQUAL "" )
      set(OMNIORB_DIR $ENV{OMNI_ROOT} )
      set(OMNIORB_FOUND TRUE)
    endif()
    set(OMNIORB_DIR ${OMNIORB_DIR} CACHE PATH "The root directory of omniORB")
    if(NOT OMNIORB_FOUND)
      message(FATAL_ERROR "omniORB required, please specify it's location.")
    endif()
  endif()
  if(OMNIORB_DIR)
    set(OMNIORB_INCLUDE_DIRS ${OMNIORB_DIR}/include)
    set(OMNIORB_LIBRARY_DIRS ${OMNIORB_DIR}/lib/x86_win32)
    include(${CMAKE_MODULE_PATH}GetOmniORBVars.cmake)
    
    if(${OMNIORB_VERSION_NUM} MATCHES "^40")
      set(OMNIORB_CFLAGS -D__WIN32__;-D__x86__;-D__NT__;-D__OSVERSION__=4;-D_CRT_SECURE_NO_DEPRECATE;-D_WIN32_WINNT=0x0400)
    else()
      set(OMNIORB_CFLAGS -D__WIN32__;-D__x86__;-D__NT__;-D__OSVERSION__=4;-D_CRT_SECURE_NO_DEPRECATE;-D_WIN32_WINNT=0x0500;-DRTC_CORBA_CXXMAPPING11)
    endif()
    set(OMNIORB_LIBRARIES_RELEASE omniORB${OMNIORB_VERSION_NUM}_rt omnithread${OMNIORB_THREAD_NUM}_rt omniDynamic${OMNIORB_VERSION_NUM}_rt )
    foreach(library ${OMNIORB_LIBRARIES_RELEASE})
      list(APPEND OMNIORB_LIBRARIES optimized ${library} debug ${library}d )
    endforeach()
  endif()
endif()

include_directories(${OMNIORB_INCLUDE_DIRS})
link_directories(${OMNIORB_LIBRARY_DIRS})

set(OMNIORB_DIR ${OMNIORB_DIR} CACHE PATH "The top directory of omniORB")
set(OMNIORB_CFLAGS ${OMNIORB_CFLAGS} CACHE STRING "Compile flags for omniORB")


# OpenRTM-aist
find_package(OpenRTM REQUIRED)
if(EXISTS "${OPENRTM_DIR}/include/openrtm-1.1/rtm/RTObjectStateMachine.h")
add_definitions(-DOPENRTM_VERSION_TRUNK)
endif()
set(ADDITIONAL_SYMBOL "")
include_directories(${OPENRTM_INCLUDE_DIRS})
link_directories(${OPENRTM_LIBRARY_DIRS})
if(UNIX)
  add_definitions(${OPENRTM_DEFINITIONS})
endif()

if( OPENRTM_VERSION STREQUAL OPENRTM_VERSION100 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION101 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION102)
  set(OPENHRP_RTM_IDL_DIR "${OpenHRP_SOURCE_DIR}/idl/OpenRTM/${OPENRTM_VERSION100}")
elseif( OPENRTM_VERSION STREQUAL OPENRTM_VERSION110 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION111 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION112 )
  set(OPENHRP_RTM_IDL_DIR "${OpenHRP_SOURCE_DIR}/idl/OpenRTM/${OPENRTM_VERSION110}")
else()
  set(OPENHRP_RTM_IDL_DIR "${OpenHRP_SOURCE_DIR}/idl/OpenRTM/${OPENRTM_VERSION}")
endif()

if( OPENRTM_VERSION STREQUAL OPENRTM_VERSION042 )
  set(ADDITIONAL_SYMBOL "OPENRTM_VERSION_042")
elseif( OPENRTM_VERSION STREQUAL OPENRTM_VERSION100 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION110 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION111 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION112 )
  set(ADDITIONAL_SYMBOL "OPENRTM_VERSION110")
endif()

if(UNIX)
  if(OPENRTM_VERSION STREQUAL OPENRTM_VERSION110 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION111 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION112)
    set(OPENRTM_IDL_DIR "${OPENRTM_DIR}/include/openrtm-1.1/rtm/idl")
  elseif(OPENRTM_VERSION STREQUAL OPENRTM_VERSION120 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION121 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION122)
    set(OPENRTM_IDL_DIR "${OPENRTM_DIR}/include/openrtm-1.2/rtm/idl")
  else()
    set(OPENRTM_IDL_DIR "${OPENRTM_DIR}/include/rtm/idl")
  endif()
elseif(WIN32)
  if(OPENRTM_VERSION STREQUAL OPENRTM_VERSION042)
    set(OPENRTM_IDL_DIR "${OPENHRP_RTM_IDL_DIR}")
  else()
    set(OPENRTM_IDL_DIR "${OPENRTM_DIR}/rtm/idl")
  endif()
endif()

add_definitions(${OMNIORB_CFLAGS})

# check ODE
set(ODE_DIR ${ODE_DIR} CACHE PATH "The root directory of ODE")
if(ODE_DIR)
  include_directories(${ODE_DIR}/include)
  if(UNIX)
    link_directories(${ODE_DIR}/lib/ReleaseSingleLib)
  elseif(WIN32)
    link_directories(${ODE_DIR}/lib/ReleaseSingleLib ${ODE_DIR}/lib/DebugSingleLib)
  endif()
endif()

option(COMPILE_JAVA_STUFF "Compile java stuff" OFF)
if(COMPILE_JAVA_STUFF)
  # check Java
  if(NOT JDK_DIR)
    find_package(Java)
    if(JAVA_COMPILE)
      get_filename_component(JDK_BIN_DIR ${JAVA_COMPILE} PATH)
      string(REGEX REPLACE "/bin/?" "" JDK_DIR ${JDK_BIN_DIR})
      message(STATUS "Found Java tools in ${JDK_BIN_DIR}")
    endif()
  endif()

  set(JDK_DIR ${JDK_DIR} CACHE PATH "JDK path")
  string(REGEX REPLACE "/$" "" JDK_DIR ${JDK_DIR})

  if(NOT JDK_DIR)
    set(JAVAC javac)
    set(IDLJ idlj)
    set(JAVAVM java)
    set(JAR jar)
    set(NATIVE2ASCII native2ascii)
  else()
    set(JAVAC ${JDK_DIR}/bin/javac)
    set(IDLJ ${JDK_DIR}/bin/idlj)
    set(JAVAVM ${JDK_DIR}/bin/java)
    set(JAR ${JDK_DIR}/bin/jar)
    set(NATIVE2ASCII ${JDK_DIR}/bin/native2ascii)
  endif()

  message(STATUS "JDK: ${JDK_DIR}")
else(COMPILE_JAVA_STUFF)
  message(STATUS "Not support Java")
endif(COMPILE_JAVA_STUFF)

option(COMPILE_PYTHON_STUFF "Compile python stuff" ON)

# jython
if(COMPILE_JAVA_STUFF)
  find_package(Jython REQUIRED)
  if(JYTHON_JAR)

=== java/CMakeLists.txt ===
set(ECLIPSE_VERISON "3.4" CACHE STRING "Set ECLIPSE_VERISON either of 3.2(Callisto) or 3.4(Ganymede)." )
set(GrxUI_ON_ECLIPSE_DIR ${OpenHRP_SOURCE_DIR}/GrxUIonEclipse-project-0.9.8)
set(DEFAULT_GRXUIRC_XML_VERSION "1.1")

set(GRXUIRC_XML_VERSION ${DEFAULT_GRXUIRC_XML_VERSION} CACHE STRING "If you change grxuirc.xml format, you should increment GRXUIRC_XML_VERSION.")

set(FIXED_CONFIGURE_COMMENT "# CMAKE generated file: DO NOT EDIT!
# Generated by \"Unix Makefiles\" Generator, CMake.
# If you want to enable the changes permanently, edit")


# GrxUI Preference Default Setting
if(CMAKE_INSTALL_PREFIX)
  STRING(REGEX REPLACE "\\\\" "/" CMAKE_INSTALL_PREFIX_TMP "${CMAKE_INSTALL_PREFIX}")
  STRING(REGEX REPLACE "/$" "" CMAKE_INSTALL_PREFIX_TMP "${CMAKE_INSTALL_PREFIX_TMP}")
  set(PREFERENCE_PROJECT_DIR "${CMAKE_INSTALL_PREFIX_TMP}/share/OpenHRP-3.1/sample/project")
  set(PREFERENCE_SERVER_DIR "${CMAKE_INSTALL_PREFIX_TMP}/bin")
else()
  set(PREFERENCE_PROJECT_DIR "")
  set(PREFERENCE_SERVER_DIR "")
endif()
if(JYTHON_HOME)
  STRING(REGEX REPLACE "\\\\" "/" PREFERENCE_JYTHON_LIB "${JYTHON_HOME}")
  STRING(REGEX REPLACE "/$" "" PREFERENCE_JYTHON_LIB "${PREFERENCE_JYTHON_LIB}")
  set(PREFERENCE_JYTHON_LIB "${PREFERENCE_JYTHON_LIB}/Lib")
else()
  set(PREFERENCE_JYTHON_LIB "")
endif()
set(CONFIGURE_COMMENT "${FIXED_CONFIGURE_COMMENT} PreferenceInitializer.java.input.")
configure_file(${GrxUI_ON_ECLIPSE_DIR}/src/com/generalrobotix/ui/grxui/PreferenceInitializer.java.input ${GrxUI_ON_ECLIPSE_DIR}/src/com/generalrobotix/ui/grxui/PreferenceInitializer.java @ONLY)


# Copy jython.jar
if(JYTHON_JAR)
  configure_file(${JYTHON_JAR} ${GrxUI_ON_ECLIPSE_DIR}/jython.jar COPYONLY)
endif()

macro(configure_grxui_on_eclipse)
  set(depends_rtm_path "src/com/generalrobotix/ui/depends/rtm")
  set(CONFIGURE_COMMENT "${FIXED_CONFIGURE_COMMENT} ClockGeneratorRtm_impl.java.in.")
  CONFIGURE_FILE( ${GrxUI_ON_ECLIPSE_DIR}/${depends_rtm_path}/ClockGeneratorRtm_impl.java.in ${GrxUI_ON_ECLIPSE_DIR}/${depends_rtm_path}/ClockGeneratorRtm_impl.java )
  CONFIGURE_FILE( ${GrxUI_ON_ECLIPSE_DIR}/META-INF/MANIFEST.MF.in ${GrxUI_ON_ECLIPSE_DIR}/META-INF/MANIFEST.MF)
  CONFIGURE_FILE( ${GrxUI_ON_ECLIPSE_DIR}/classpath.in ${GrxUI_ON_ECLIPSE_DIR}/.classpath)
  CONFIGURE_FILE( ${GrxUI_ON_ECLIPSE_DIR}/plugin.xml.in ${GrxUI_ON_ECLIPSE_DIR}/plugin.xml)
  CONFIGURE_FILE( ${GrxUI_ON_ECLIPSE_DIR}/build.properties.in ${GrxUI_ON_ECLIPSE_DIR}/build.properties)
endmacro()


# Specific Eclipse version
set( ORG_ECLIPSE_UI_VERSION "")
set( ORG_ECLIPSE_CORE_RUNTIME_VERSION "")
set( ORG_ECLIPSE_CORE_RESOURCES_VERSION "")

if( ECLIPSE_VERISON STREQUAL "3.4")
  set( ORG_ECLIPSE_UI_VERSION ";bundle-version=\"3.4.2\"")
  set( ORG_ECLIPSE_CORE_RUNTIME_VERSION ";bundle-version=\"3.4.0\"")
  set( ORG_ECLIPSE_CORE_RESOURCES_VERSION ";bundle-version=\"3.4.2\"")
endif()

# Set OS_NAME
if(UNIX)
  set(OS_NAME linux)
endif(UNIX)
if(WIN32)
  set(OS_NAME windows)
endif(WIN32)

# Specific OpenRTM version

if( ${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION042} )
  set(rtm_stub_jar OpenRTM-aist-0.4.1.jar)
  set(ADDITIONAL_EXCLUDING "")
  set(EXT_TRIG_EXECUTION_CONTEXT_SERVICE "RTC.ExtTrigExecutionContextService")
  set(GRX_PATH_PLANNING_ALGORITHM_ITEM "<item class=\"com.generalrobotix.ui.item.GrxPathPlanningAlgorithmItem\"/>" )


  set(GRX_PATH_PLANNING_VIEW_PART "
      <view
            class=\"com.generalrobotix.ui.view.GrxPathPlanningViewPart\"
            id=\"com.generalrobotix.ui.view.GrxPathPlanningViewPart\"
            category=\"com.generalrobotix.ui.view\"
            name=\"%PathPlanningView.name\">
      </view>" )

  set(OPEN_EXPORT_PACKAGE " jp.go.aist.hrp.simulator.ModelLoaderPackage,
 jp.go.aist.rtm,
 jp.go.aist.rtm.RTC,
 jp.go.aist.rtm.RTC.SDOPackage,
 jp.go.aist.rtm.RTC.buffer,
 jp.go.aist.rtm.RTC.executionContext,
 jp.go.aist.rtm.RTC.log,
 jp.go.aist.rtm.RTC.port,
 jp.go.aist.rtm.RTC.port.publisher,
 jp.go.aist.rtm.RTC.util" )

 configure_grxui_on_eclipse()
elseif(${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION100} OR ${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION101} OR ${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION102} OR ${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION110})
  if(${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION100} OR ${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION101} OR ${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION102} )
    set(rtm_stub_jar OpenRTM-aist-1.0.0.jar)
  elseif(${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION110})
    set(rtm_stub_jar OpenRTM-aist-1.1.0.jar)
  endif()
  set(ADDITIONAL_EXCLUDING "")
  set(EXT_TRIG_EXECUTION_CONTEXT_SERVICE "OpenRTM.ExtTrigExecutionContextService")
  set(GRX_PATH_PLANNING_ALGORITHM_ITEM "<item class=\"com.generalrobotix.ui.item.GrxPathPlanningAlgorithmItem\"/>" )
  set(GRX_PATH_PLANNING_VIEW_PART "
      <view
            class=\"com.generalrobotix.ui.view.GrxPathPlanningViewPart\"
            id=\"com.generalrobotix.ui.view.GrxPathPlanningViewPart\"
            category=\"com.generalrobotix.ui.view\"
            name=\"%PathPlanningView.name\">
      </view>" )
  set(OPEN_EXPORT_PACKAGE " jp.go.aist.hrp.simulator.ModelLoaderPackage")

  configure_grxui_on_eclipse()

else()
# Unsupported OPENRTM_VERSION configure
  set(rtm_stub_jar openrtmstubskel.jar)

# To set supported latest OPENRTM_VERSION
  set(ADDITIONAL_EXCLUDING "|com/generalrobotix/ui/view/GrxPathPlanning*.java|jp/**/*.java")
  set(EXT_TRIG_EXECUTION_CONTEXT_SERVICE "OpenRTM.ExtTrigExecutionContextService")
  set(GRX_PATH_PLANNING_ALGORITHM_ITEM "" )
  set(GRX_PATH_PLANNING_VIEW_PART "" )
  set(OPEN_EXPORT_PACKAGE " jp.go.aist.hrp.simulator.ModelLoaderPackage,
 RTM,
 jp.go.aist.openrtm.OpenRTM,
 jp.go.aist.openrtm.RTC" )
  add_subdirectory(rtmStubCorba)
  message(STATUS "OpenRTM version is ${OPENRTM_VERSION}. Generate Makefile compiles openrtmstubskel.jar.")

  configure_grxui_on_eclipse()
endif()

ADD_SUBDIRECTORY(corba)

# install(FILES vrml97.jar DESTINATION ${RELATIVE_JAVA_INSTALL_PATH})

=== sample/CMakeLists.txt ===
add_subdirectory(controller)
if(OPENRTM_VERSION VERSION_GREATER OPENRTM_VERSION100 OR OPENRTM_VERSION VERSION_EQUAL OPENRTM_VERSION100)
  add_subdirectory(example)
  add_subdirectory(JoystickControl)
endif()

if( COLLADA_DOM_FOUND )
  file(GLOB_RECURSE _wrlfiles *.wrl)
  set(_daefiles)
  foreach(_wrlfile ${_wrlfiles})
    string(REGEX REPLACE ".wrl$" ".dae" _daefile ${_wrlfile})
    file(STRINGS ${_wrlfile} _robotmodel REGEX "DEF .* Humanoid")
    if(${_wrlfile} MATCHES "mockup/mockup_main.wrl")
      set(_robotmodel "")  # mock_main.wrl sometimes fail to convert on travis
    endif()
    if(NOT _robotmodel STREQUAL "")
      add_custom_command(OUTPUT ${_daefile}
        COMMAND ../bin/openhrp-export-collada -i ${_wrlfile} -o ${_daefile}
        DEPENDS ../bin/openhrp-export-collada ${_wrlfile})
      string(REGEX REPLACE "\\." "_" _daefile_target ${_daefile})
      list(APPEND _daefiles ${_daefile})
    endif()
  endforeach()
  add_custom_target(export_collada_models ALL DEPENDS ${_daefiles})
endif()

install(DIRECTORY model project script
  DESTINATION ${RELATIVE_SAMPLE_INSTALL_PATH}
  PATTERN ".svn" EXCLUDE PATTERN "mockup" EXCLUDE)

=== script/CMakeLists.txt ===

# @author Shin'ichiro Nakaoka

set(grxui_script_list
  openhrp-jython-prompt
  openhrp-shutdown-servers
  )

macro(create_bootscripts DESTINATION DO_INSTALL)
  
  # This is needed. CMake's bug ?
  set(DO_INSTALL ${DO_INSTALL})

  foreach(script ${grxui_script_list} )
    
    if(WIN32)
      set(script ${script}.${SH_SFX})
    endif()

    configure_file(${script}.in ${DESTINATION}/${script} @ONLY)
    if(DO_INSTALL)
      install(PROGRAMS ${DESTINATION}/${script} DESTINATION bin)
    endif()
  endforeach()
 
endmacro()


set(OPENHRPHOME ${PROJECT_BINARY_DIR})
set(OPENHRP_CONFDIR_NAME .OpenHRP-${OPENHRP_VERSION_MAJOR}.${OPENHRP_VERSION_MINOR})
set(GRXUI_JAVAVM ${JAVAVM})
set(GRXUI_JYTHON_HOME ${JYTHON_HOME})
set(GRXUI_LD_LIBRARY_PATH "${JAVA_LD_LIBRARY_PATH}")
set(GRXUI_ADDITIONAL_PATH ${OPENHRPHOME}/bin)
set(GRXUI_CLASSPATH ${PROJECT_BINARY_DIR}/java/grxui.jar${CPSEP}${PROJECT_BINARY_DIR}/java/openhrpstubskel.jar${CPSEP}${CLASSPATH})

# TODO: set a full path if the program is not in the PATH
if(UNIX)
  set(OMNINAMES omniNames)
elseif(WIN32)
  set(OMNINAMES ${OMNIORB_DIR}/bin/x86_win32/omniNames)
endif()

# TODO: enable the follwoing values to be edited
set(NS_PORT 2809)
set(NS_HOST localhost)

create_bootscripts(${PROJECT_BINARY_DIR}/bin false)



set(OPENHRPHOME ${CMAKE_INSTALL_PREFIX})
if(NOT ${OPENHRPHOME} STREQUAL /usr OR ${OPENHRPHOME} STREQUAL /usr/local)
  set(GRXUI_ADDITIONAL_PATH ${OPENHRPHOME}/bin)
endif()
set(GRXUI_CLASSPATH ${OPENHRPHOME}/${RELATIVE_GRXUI_INSTALL_PATH}/grxui.jar${CPSEP}${OPENHRPHOME}/${RELATIVE_JAVA_INSTALL_PATH}/openhrpstubskel.jar${CPSEP}${CLASSPATH})
set(RELATIVE_JAVA_INSTALL_PATH share/${OPENHRP_INSTALL_SUB_DIR}/java)

create_bootscripts(${CMAKE_CURRENT_BINARY_DIR} true)

=== hrplib/hrpCorba/CMakeLists.txt ===

# @author Shin'ichiro Nakaoka

include(${OPENHRP_IDL_DIR}/OpenHRP/IDL_FILE_BASENAMES.cmake)

set(idl_flags_cpp ${VERBOSE_FLAG} -bcxx -Wbuse_quotes -Wbh=.hh -Wbs=Sk.cpp -I${OPENRTM_IDL_DIR})
set(idl_flags_py  ${VERBOSE_FLAG} -bpython -I${OPENRTM_IDL_DIR})

if( NOT ADDITIONAL_SYMBOL STREQUAL "")
  set(idl_flags_cpp ${idl_flags_cpp} -D ${ADDITIONAL_SYMBOL})
  set(idl_flags_py  ${idl_flags_py}  -D ${ADDITIONAL_SYMBOL})
endif()


foreach(name ${IDL_FILE_BASENAMES})
  set(idl_files ${idl_files} ${OPENHRP_IDL_DIR}/OpenHRP/${name}.idl)
  set(idl_cpp_files ${idl_cpp_files} ${CMAKE_CURRENT_BINARY_DIR}/${name}Sk.cpp)
  set(idl_h_files ${idl_h_files} ${CMAKE_CURRENT_BINARY_DIR}/${name}.hh)
  set(idl_py_files ${idl_py_files} ${CMAKE_CURRENT_BINARY_DIR}/${name}_idl.py)
endforeach()

foreach(idl_basename ${IDL_FILE_BASENAMES})
  set(idl_file ${OPENHRP_IDL_DIR}/OpenHRP/${idl_basename}.idl)
  if(UNIX)
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${idl_basename}.hh ${CMAKE_CURRENT_BINARY_DIR}/${idl_basename}Sk.cpp
      COMMAND omniidl ${idl_flags_cpp} ${idl_file}
      DEPENDS ${idl_files}
      )
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${idl_basename}_idl.py
      COMMAND omniidl ${idl_flags_py} ${idl_file}
      DEPENDS ${idl_files}
      )
  elseif(WIN32)
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${idl_basename}.hh ${CMAKE_CURRENT_BINARY_DIR}/${idl_basename}Sk.cpp
      COMMAND set PATH= "${OMNIORB_DIR}/bin/x86_win32"\;%PATH%
      COMMAND omniidl ${idl_flags_cpp} ${idl_file}
      DEPENDS ${idl_files}
      )
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${idl_basename}_idl.py
      COMMAND set PATH= "${OMNIORB_DIR}/bin/x86_win32"\;%PATH%
      COMMAND omniidl ${idl_flags_py} ${idl_file}
      DEPENDS ${idl_files}
      )
  endif()
endforeach()

set(target hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION})

if (COMPILE_PYTHON_STUFF)
  add_library(${target} STATIC ${idl_cpp_files} ${idl_py_files})
else()
  add_library(${target} STATIC ${idl_cpp_files})
endif()

if(UNIX)
  set_target_properties(${target} PROPERTIES COMPILE_FLAGS -fPIC)
endif()

if(WIN32)
  set_target_properties(${target} PROPERTIES DEBUG_POSTFIX d)
endif() 

if(WIN32)
install(TARGETS ${target}
	RUNTIME DESTINATION ${PROJECT_BINARY_DIR}/bin CONFIGURATIONS Release Debug
	LIBRARY DESTINATION ${PROJECT_BINARY_DIR}/lib CONFIGURATIONS Release Debug
	ARCHIVE DESTINATION ${PROJECT_BINARY_DIR}/lib CONFIGURATIONS Release Debug
)
endif()

install(TARGETS ${target}
	RUNTIME DESTINATION bin CONFIGURATIONS Release Debug RelWithDebInfo
	LIBRARY DESTINATION lib CONFIGURATIONS Release Debug RelWithDebInfo
	ARCHIVE DESTINATION lib CONFIGURATIONS Release Debug RelWithDebInfo
)

set(given_headers ORBwrap.h)

install(FILES ${given_headers} ${idl_h_files} DESTINATION ${RELATIVE_HEADERS_INSTALL_PATH}/hrpCorba)
execute_process(
  COMMAND python -c "import sys; print('%s.%s'%(sys.version_info[0:2]))"
  OUTPUT_VARIABLE python_version
  OUTPUT_STRIP_TRAILING_WHITESPACE)

if (COMPILE_PYTHON_STUFF)
  install(FILES ${idl_py_files} DESTINATION lib/python${python_version}/dist-packages)
  set(module_py_files ${CMAKE_CURRENT_BINARY_DIR}/OpenHRP/__init__.py)
  install(FILES ${module_py_files} DESTINATION lib/python${python_version}/dist-packages/OpenHRP)
  set(module_poa_py_files ${CMAKE_CURRENT_BINARY_DIR}/OpenHRP__POA/__init__.py)
  install(FILES ${module_poa_py_files} DESTINATION lib/python${python_version}/dist-packages/OpenHRP__POA)
endif()

=== hrplib/hrpModel/CMakeLists.txt ===

configure_file(Config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/Config.h)

set(sources
  Sensor.cpp
  Light.cpp
  Body.cpp
  BodyCustomizerInterface.cpp
  Link.cpp
  LinkTraverse.cpp
  LinkPath.cpp
  JointPath.cpp
  ColdetLinkPair.cpp
  ForwardDynamics.cpp
  ForwardDynamicsABM.cpp
  ForwardDynamicsCBM.cpp
  World.cpp
  ConstraintForceSolver.cpp
  ModelNodeSet.cpp
  ModelLoaderUtil.cpp
  OnlineViewerUtil.cpp
  )

set(headers
  Body.h
  BodyCustomizerInterface.h
  ConstraintForceSolver.h
  ForwardDynamics.h
  ForwardDynamicsABM.h
  ForwardDynamicsCBM.h
  Link.h
  LinkTraverse.h
  LinkPath.h
  JointPath.h
  ColdetLinkPair.h
  InverseKinematics.h
  ModelNodeSet.h
  ModelLoaderUtil.h
  OnlineViewerUtil.h
  Sensor.h
  Light.h
  World.h
  Config.h
  )	


set(target hrpModel-${OPENHRP_LIBRARY_VERSION})

add_library(${target} SHARED ${sources})

# interface version 0.0.0 - version 3.0.0 beta1
set(HRPMODEL_VERSION ${HRPSOVERSION}.0.0 )
set_target_properties(${target} PROPERTIES VERSION ${HRPMODEL_VERSION} SOVERSION ${HRPSOVERSION})


if(UNIX)
  if(NOT QNXNTO)
    target_link_libraries(${target}
      hrpUtil-${OPENHRP_LIBRARY_VERSION}
      hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION}
      hrpCollision-${OPENHRP_LIBRARY_VERSION}
      ${OMNIORB_LIBRARIES}
      #boost_filesystem boost_regex
      ${Boost_REGEX_LIBRARY}
      #${Boost_LIBRARIES}
      dl)
  else(NOT QNXNTO)
    target_link_libraries(${target}
      hrpUtil-${OPENHRP_LIBRARY_VERSION}
      hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION}
      hrpCollision-${OPENHRP_LIBRARY_VERSION}
      #${OMNIORB_LIBRARIES}
      ${OPENRTM_LIBRARIES}
      #boost_filesystem boost_regex boost_system boost_signals
      ${Boost_LIBRARIES}
      )
  endif(NOT QNXNTO)
elseif(WIN32)
  add_definitions(-DHRPMODEL_MAKE_DLL)
  target_link_libraries(${target}
    optimized hrpUtil-${OPENHRP_LIBRARY_VERSION}
    optimized hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION}
    optimized hrpCollision-${OPENHRP_LIBRARY_VERSION}
    debug hrpUtil-${OPENHRP_LIBRARY_VERSION}d
    debug hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION}d
    debug hrpCollision-${OPENHRP_LIBRARY_VERSION}d
    ${OMNIORB_LIBRARIES})
  set_target_properties(${target} PROPERTIES LINK_FLAGS /NODEFAULTLIB:LIBCMT )
  set_target_properties(${target} PROPERTIES DEBUG_POSTFIX d )
endif()

hrplib_install_macro(${target} ${HRPMODEL_VERSION})

install(FILES ${headers} DESTINATION ${RELATIVE_HEADERS_INSTALL_PATH}/hrpModel)

# Body Customizers
set(OPENHRP_3_0_CUSTOMIZERS ${OPENHRP_3_0_CUSTOMIZERS} CACHE FILEPATH "Source files of the body customizer for OpenHRP 3.0")

if(OPENHRP_3_0_CUSTOMIZERS)

  foreach(src ${OPENHRP_3_0_CUSTOMIZERS})

    get_filename_component(customizer ${src} NAME_WE)
    add_library(${customizer} SHARED ${src})
    set_target_properties(${customizer} PROPERTIES COMPILE_FLAGS "-I${CMAKE_CURRENT_SOURCE_DIR}")
    set_target_properties(${customizer} PROPERTIES PREFIX "")
    set_target_properties(${customizer} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/customizer)

    if(WIN32)
      install(TARGETS ${customizer}
        DESTINATION ${RELATIVE_SHARE_INSTALL_PATH}/customizer CONFIGURATIONS Release Debug)
    else()
      install(TARGETS ${customizer}
        LIBRARY DESTINATION ${RELATIVE_SHARE_INSTALL_PATH}/customizer CONFIGURATIONS Release Debug RelWithDebInfo)
    endif()
  endforeach()
endif()

=== hrplib/hrpRTM/CMakeLists.txt ===
set(sources
  SimulationExecutionContext.cpp
)

if( NOT ADDITIONAL_SYMBOL STREQUAL "")
  add_definitions(-D${ADDITIONAL_SYMBOL})
endif()

set(target SimulationEC )

add_library(${target} SHARED ${sources})
set_target_properties(${target} PROPERTIES PREFIX "")
if(WIN32)
  set_target_properties(${target} PROPERTIES DEBUG_POSTFIX d )
endif()
# interface version 0.0.0 - version 3.0.0 beta1
set(HRPRTM_VERSION ${HRPSOVERSION}.0.0 )
set_target_properties(${target} PROPERTIES VERSION ${HRPRTM_VERSION} SOVERSION ${HRPSOVERSION})

target_link_libraries(${target}
  ${OPENRTM_LIBRARIES} hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION}
)

install(TARGETS ${target}
  RUNTIME DESTINATION bin CONFIGURATIONS Release Debug RelWithDebInfo
  LIBRARY DESTINATION lib CONFIGURATIONS Release Debug RelWithDebInfo
  ARCHIVE DESTINATION lib CONFIGURATIONS Release Debug RelWithDebInfo
)

=== sample/JoystickControl/CMakeLists.txt ===
if(${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION100} OR ${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION101} OR ${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION102} )
  set(rtm_stub_jar OpenRTM-aist-1.0.0.jar)
elseif(${OPENRTM_VERSION} STREQUAL ${OPENRTM_VERSION110})
  set(rtm_stub_jar OpenRTM-aist-1.1.0.jar)
endif()
CONFIGURE_FILE( JoystickComponent-project/META-INF/MANIFEST.MF.in JoystickComponent-project/META-INF/MANIFEST.MF)
CONFIGURE_FILE( JoystickComponent-project/build.properties.in JoystickComponent-project/build.properties)
CONFIGURE_FILE( Controller/JoystickControllerAutomated.bat.in Controller/JoystickControllerAutomated.bat)
CONFIGURE_FILE( Controller/JoystickController.bat.in Controller/JoystickControlle.bat)

install(FILES JoystickContorller.xml JoystickConnection.rtclink SimulationProject.xml
  DESTINATION ${RELATIVE_SAMPLE_INSTALL_PATH}/JoystickControl)

if(GENERATE_DEBIANPACKAGE)
  install(DIRECTORY Controller
    DESTINATION ${RELATIVE_SAMPLE_INSTALL_PATH}/JoystickControl
    PATTERN ".svn" EXCLUDE
    PATTERN "*.bat" EXCLUDE
    PATTERN "*.sln" EXCLUDE
    PATTERN "*.vsprops" EXCLUDE
    PATTERN "*.vcproj" EXCLUDE)

#  CPack Bug? Long path is over flow to /.
#  install(DIRECTORY JoystickComponent-project
#    DESTINATION ${RELATIVE_SAMPLE_INSTALL_PATH}/JoystickControl
#    PATTERN ".svn" EXCLUDE )

  install(FILES JoystickComponent-project.zip
    DESTINATION ${RELATIVE_SAMPLE_INSTALL_PATH}/JoystickControl)

else()
  install(DIRECTORY Controller JoystickComponent-project
    DESTINATION ${RELATIVE_SAMPLE_INSTALL_PATH}/JoystickControl
    PATTERN ".svn" EXCLUDE 
    PATTERN "bin" EXCLUDE )

endif(GENERATE_DEBIANPACKAGE)

=== sample/controller/CMakeLists.txt ===
set(LIBRARY_OUTPUT_PATH)
set(EXECUTABLE_OUTPUT_PATH)

macro(create_simple_controller CONTROLLER_NAME)

  add_library(${CONTROLLER_NAME} SHARED ${CONTROLLER_NAME}.cpp)
  target_link_libraries(${CONTROLLER_NAME} ${OPENRTM_LIBRARIES})
  set_target_properties(${CONTROLLER_NAME} PROPERTIES PREFIX "")

  add_executable(${CONTROLLER_NAME}Comp ${CONTROLLER_NAME}Comp.cpp ${CONTROLLER_NAME}.cpp)
  target_link_libraries(${CONTROLLER_NAME}Comp ${OPENRTM_LIBRARIES})

  if(WIN32)
    add_definitions(${OPENRTM_DEFINITIONS})
    set_target_properties(${CONTROLLER_NAME}Comp PROPERTIES DEBUG_POSTFIX d )
  endif()

  set(controller_install_path ${RELATIVE_SAMPLE_INSTALL_PATH}/controller/${CONTROLLER_NAME})

  install(TARGETS ${CONTROLLER_NAME} ${CONTROLLER_NAME}Comp DESTINATION ${controller_install_path} CONFIGURATIONS Release Debug RelWithDebInfo)
  
  if(WIN32)
    install(TARGETS ${CONTROLLER_NAME} ${CONTROLLER_NAME}Comp
        DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}
        CONFIGURATIONS Release )
  endif()

  install(PROGRAMS ${CONTROLLER_NAME}.${SH_SFX} DESTINATION ${controller_install_path})
  
  install(FILES rtc.conf bridge.conf DESTINATION ${controller_install_path})

  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/etc)
    install(DIRECTORY etc DESTINATION ${controller_install_path} PATTERN ".svn" EXCLUDE)
  endif()

endmacro()

if(OPENRTM_VERSION VERSION_GREATER OPENRTM_VERSION100 OR OPENRTM_VERSION VERSION_EQUAL OPENRTM_VERSION100)
    add_subdirectory(SamplePD)
    add_subdirectory(SampleHG)
    add_subdirectory(SampleLF)
    add_subdirectory(SampleSV)
    add_subdirectory(SampleController)
    add_subdirectory(SamplePD_HG)
    add_subdirectory(PD_HGtest)
    add_subdirectory(PA10Controller)
    add_subdirectory(SampleRH2)
    add_subdirectory(SampleCrawler)
endif()

=== sample/example/CMakeLists.txt ===
add_subdirectory(scheduler)
add_subdirectory(simulationEC)
add_subdirectory(customizer)
add_subdirectory(move_ankle)
add_subdirectory(clap)
add_subdirectory(viewSimulator)

=== server/AistDynamicsSimulator/CMakeLists.txt ===
# @author Shin'ichiro Nakaoka

set(program openhrp-aist-dynamics-simulator)

set(sources DynamicsSimulator_impl.cpp server.cpp)

add_executable(${program} ${sources})

if(UNIX)
  target_link_libraries(${program}
    hrpUtil-${OPENHRP_LIBRARY_VERSION}
    hrpModel-${OPENHRP_LIBRARY_VERSION}
    hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION}
    ${OMNIORB_LIBRARIES} ${Boost_REGEX_LIBRARY} )
elseif(WIN32)
  set_target_properties(${program} PROPERTIES DEBUG_POSTFIX d)
  target_link_libraries(${program}
    optimized hrpUtil-${OPENHRP_LIBRARY_VERSION}
    optimized hrpModel-${OPENHRP_LIBRARY_VERSION}
    optimized hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION}
    debug hrpUtil-${OPENHRP_LIBRARY_VERSION}d
    debug hrpModel-${OPENHRP_LIBRARY_VERSION}d
    debug hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION}d
    ${OMNIORB_LIBRARIES})  
endif()

if(WIN32)
install(TARGETS ${program} DESTINATION ${PROJECT_BINARY_DIR}/bin CONFIGURATIONS Release)
endif()

install(TARGETS ${program} DESTINATION bin CONFIGURATIONS Release Debug RelWithDebInfo)

=== server/CollisionDetector/CMakeLists.txt ===

set(program openhrp-collision-detector)

set(sources
  ColdetBody.cpp
  CollisionDetector_impl.cpp
  server.cpp)

add_executable(${program} ${sources})

if(UNIX)
  target_link_libraries(${program}
    hrpUtil-${OPENHRP_LIBRARY_VERSION}
    hrpCollision-${OPENHRP_LIBRARY_VERSION}
    hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION}
    ${OMNIORB_LIBRARIES})
elseif(WIN32)
  set_target_properties(${program} PROPERTIES DEBUG_POSTFIX d)
  target_link_libraries(${program} 
    optimized hrpUtil-${OPENHRP_LIBRARY_VERSION}
    optimized hrpCollision-${OPENHRP_LIBRARY_VERSION}
    optimized hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION} 
    debug hrpUtil-${OPENHRP_LIBRARY_VERSION}d
    debug hrpCollision-${OPENHRP_LIBRARY_VERSION}d
    debug hrpCorbaStubSkel-${OPENHRP_LIBRARY_VERSION}d
    ${OMNIORB_LIBRARIES})  
endif()

if(WIN32)
install(TARGETS ${program} DESTINATION ${PROJECT_BINARY_DIR}/bin CONFIGURATIONS Release)
endif()

install(TARGETS ${program} DESTINATION bin CONFIGURATIONS Release Debug RelWithDebInfo)

=== debian/changelog ===
ros-noetic-openhrp3 (3.1.10-1buster) buster; urgency=high

  * hrplib/hrpModel
    
      * [hrplib/hrpModel/ForwardDynamicsCBM.cpp] check equation num in solveUnknownAccels (#155 <https://github.com/fkanehiro/openhrp3/issues/155>)
      * [hrplib/hrpModel] Calculation of the mass of a portion of the kinematic chain (#142 <https://github.com/fkanehiro/openhrp3/issues/142>)
        
          * Add calcTotalMass to LinkTraverse
          * Added calcJacobianDot to JointPath
          * Calculation of the spatial velocity
        
      * [hrplib/hrpModel/ModelNodeSet.cpp] change the way to check existence of children field (#139 <https://github.com/fkanehiro/openhrp3/issues/139>)
      * [hrpModel/JointPath.cpp] try to enforce joint limits in calcInverseKinetatics() (#137 <https://github.com/fkanehiro/openhrp3/issues/137>)
      * [hrplib/hrpModel/JointPath.cpp] add local_p arg for calcJacobian (#127 <https://github.com/fkanehiro/openhrp3/issues/127>)
        
          * fix local_p coordinate
          * add local_p arg for calcJacobian
        
    
  * hrplib/hrpPlanner
    
      * [hrplib/hrpPlanner] fix warnings(-Wdelete-incomplete) (#138 <https://github.com/fkanehiro/openhrp3/issues/138>)
      * [hrplib/hrpPlanner/TimeUtil.cpp] add stdint.h to use uint64_t on arm, close #123 <https://github.com/fkanehiro/openhrp3/issues/123> (#124 <https://github.com/fkanehiro/openhrp3/issues/124>)
    
  * hrplib/hrpCollision
    
      * [hrplib/hrpCollision] enable to bypass normal vector correction (#141 <https://github.com/fkanehiro/openhrp3/issues/141>)
      * [hrpCollision] add ColdetModelPair::operator=() (#136 <https://github.com/fkanehiro/openhrp3/issues/136>)
    
  * hrplib/hrpUtil
    
      * [hrplib/hrpUtil/EasyScanner.cpp] Always use locale-free variant of strtod (#144 <https://github.com/fkanehiro/openhrp3/issues/144>)
      * [hrplib/hrpUtil/testEigen3d.cpp] Fix C++11 support (#134 <https://github.com/fkanehiro/openhrp3/issues/134>)
    
  * server/ModelLoader
    
      * [server/ModelLoader/projectGenerator.cpp] write peridoic.rate to conf file (#156 <https://github.com/fkanehiro/openhrp3/issues/156>)
      * [server/ModelLoader/ColladaWriter.h] Apply abs when computing max_torque (#153 <https://github.com/fkanehiro/openhrp3/issues/153>)
      * [server/ModelLoader/ColladaWriter.h] Fix missing return statement (#152 <https://github.com/fkanehiro/openhrp3/issues/152>)
      * [server/ModelLoader] Check if segment node is defined (#135 <https://github.com/fkanehiro/openhrp3/issues/135>)
      * [server/ModelLoader/ColladaWriter.h] Changed ambientcolor (#133 <https://github.com/fkanehiro/openhrp3/issues/133>)
    
  * sample
    
      * [sample/model/sample1_bush.wrl] add comma (#154 <https://github.com/fkanehiro/openhrp3/issues/154>)
    
  * CMake
    
      * [CMakeLists.txt, hrplib/hrpCorba/CMakeLists.txt] add an option COMPILE_PYTHON_STUFF
      * [CMakeLists.txt, cmake_modules/FindOpenRTM.cmake] enable to compile with OpenRTM 1.2.2
      * [CMakeLists.txt, server/ModelLoader/CMakeLists.txt] support newer boost (#146 <https://github.com/fkanehiro/openhrp3/issues/146>)
    
  * [openhrp3.1.pc.in] fix path order in openhrp3.1.pc.in (#129 <https://github.com/fkanehiro/openhrp3/issues/129>)
  * installPackages
    
      * [util]
        
          * add packages.list.ubuntu.20.04
          * add packages.list.debian.9
          * add packages.list.debian.10
          * update package list
          * add packages.list.ubuntu.18.04
        
      * [uril] add a package list for debian7
      * [util/pkg_install_debian.sh] add RTM repository without asking user
      * [uril] install packages without asking user
    
  * Enable GithubAction tests (#155 <https://github.com/fkanehiro/openhrp3/issues/155>)
    
      * noetic does not run test because of missing python3 omniorb
      * [test/test_openhrp3.py] fix python3 error on mixing binary and string
        ```
        raise TypeError("Can't mix strings and bytes in path components") from None
        ```
      * install python3-rosdep if python-rosdep failed
      * try without openrtm-aist-python
      * remove esm repos
      * compile example and JoysticControl in newer openrtm than 1.1.0
        * [sample/controller/CMakeLists.txt] add sample/controller/{SamplePD,SampleHG,SampleLF} when >= OPENRTM_VERSION100  (#150 <https://github.com/fkanehiro/openhrp3/issues/150>)
        * CMake < 3.7 compatibility, see https://github.com/glfw/glfw/issues/1584
        * [sample/CMakeLists.txt] [sample] compile example and JoysticControl in newer openrtm than 1.1.0
      * hrplib/hrpCorba/CMakeLists.txt: fix for Python3
      * patch trusty-hrpsys-util.patch, https://github.com/fkanehiro/hrpsys-base/pull/1308 fails on 14.04
      * add indigo/kinetic, run rosdep update with --include-eol-distros
      * fix for python3: 2to3 -w -f has_key .
      * fix for python3: 2to3 -w -f print .
      * add .github/workflows/config.yml
    
  * TravisCI
    
      * add .travis.yml and create .travis.sh (#149 <https://github.com/fkanehiro/openhrp3/issues/149>)
      * [.travis.yml] update dpkg to install rosdistro in trusty (#143 <https://github.com/fkanehiro/openhrp3/issues/143>)
      * .travis.yml : update to trusty/indigo (#128 <https://github.com/fkanehiro/openhrp3/issues/128>)
    
  * Contributors: Fumio Kanehiro, Iori Kumagai, Jun Inoue, Kei Okada, Mitsuharu Morisawa, Naoki Hiraoka, Pierre Gergondet, Rafael Cisneros, Iori Yanokura, Yasuhiro Ishiguro, Kunio Kojima

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 09 Jun 2022 15:00:00 -0000

ros-noetic-openhrp3 (3.1.9-1buster) buster; urgency=high

  * supports OpenRTM-aist 1.2.0 (c04e9293 <https://github.com/fkanehiro/openhrp3/commit/c04e92930af318d6566213dd173c34331eb18898>)
  * supports trunk version of OpenRTM-aist (#104 <https://github.com/fkanehiro/openhrp3/issues/104>)


=== debian/control ===
Source: ros-noetic-openhrp3
Section: misc
Priority: optional
Maintainer: Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>
Build-Depends: debhelper (>= 9.0.0), cmake, doxygen, f2c, jython, libatlas-base-dev, libboost-all-dev, libcollada-dom2.4-dp-dev, libeigen3-dev, libf2c2, libf2c2-dev, libjpeg-dev, libpng-dev, libxml2-dev, omniidl-python, pkg-config, python-omniorb, python-omniorb-omg, ros-noetic-openrtm-aist
Homepage: https://openrtp.jp/svn/hrg/openhrp/
Standards-Version: 3.9.2

Package: ros-noetic-openhrp3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, f2c, jython, libatlas-base-dev, libboost-all-dev, libcollada-dom2.4-dp-dev, libeigen3-dev, libf2c2, libf2c2-dev, libjpeg-dev, libpng-dev, libxml2-dev, omniidl-python, python-omniorb, python-omniorb-omg, ros-noetic-openrtm-aist
Description: This package does not only wrap OpenHRP3 but actually provides the built artifact from the code from its mainstream repository.
 Being ROS-agnostic by itself, you can also use this via ROS together with the packages in rtmros_common that bridge between two framework. OpenHRP3 (Open Architecture Human-centered Robotics Platform version 3) is an integrated software platform for robot simulations and software developments. It allows the users to inspect an original robot model and control program by dynamics simulation. In addition, OpenHRP3 provides various software components and calculation libraries that can be used for robotics related software developments (excerpts from here). The package version number is synchronized to that of mainstream, based on this decision.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-openhrp3//opt/ros/noetic/lib/:$(CURDIR)/debian/ros-noetic-openhrp3//opt/ros/noetic/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
